<script>
  import { extent } from "d3-array";
  import { scaleLinear, scaleOrdinal } from "d3-scale";
  import { schemeRdGy } from "d3-scale-chromatic";
  
    // Dimensions
    const width = 800;
    const height = 100;
    const margin = { top: 20, right: 5, bottom: 5, left: 5 };
    const innerWidth = width - margin.left - margin.right;
    const innerHeight = height - margin.top - margin.bottom;
  
    // Array
    const values = [
      { x: 2, y: 1, category: "cat1" },
      { x: 4, y: 2, category: "cat3" },
      { x: 6, y: 1, category: "cat2" },
      { x: 7, y: 3, category: "cat3" },
      { x: 9, y: 1, category: "cat2" }
    ];
  
    const scaleX = scaleLinear([0, 10], [0, innerWidth]);
    const scaleY = scaleLinear([0, 4], [0, innerHeight]);
    const scaleColors = scaleOrdinal(
      extent(values.map((items) => items.category)),
      schemeRdGy[9]
    );
  </script>
  
  <svg viewBox="0 0 {width} {height}">
    <g transform="translate({margin.left},{margin.top})">
      {#each values as point}
      <circle
        cx={scaleX(point.x)}
        cy={innerHeight - scaleY(point.y)}
        r="10"
        style="fill: {scaleColors(point.category)}"
      />
      <text
      class="Label"
      x={scaleX(point.x)}
      y={innerHeight - scaleY(point.y) - 10}>{point.y}</text
    >
    <line
      x1={scaleX(point.x)}
      x2={scaleX(point.x)}
      y1={height}
      y2={innerHeight - scaleY(point.y)}
      style="stroke: {scaleColors(point.category)}"
    />
  {/each}
  
    </g>
  </svg>
  
  <style>
    text {
      text-anchor: middle;
      font-size: small;
    }
  </style>
  